// Copyright 2014 - 2018 Colectica.
// 
// This file is part of the Colectica Curation Tools.
// 
// The Colectica Curation Tools are free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by the
// Free Software Foundation, either version 3 of the License, or (at your option)
// any later version.
// 
// The Colectica Curation Tools are distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for
// more details.
// 
// You should have received a copy of the GNU Affero General Public License along
// with Colectica Curation Tools. If not, see <https://www.gnu.org/licenses/>.

﻿using Colectica.Curation.Web.Models;
using log4net;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Colectica.Curation.Web.Controllers
{
    public class ErrorController : CurationControllerBase
    {
        public ActionResult Index(int statusCode, Exception exception, bool isAjaxRequest)
        {
            var logger = LogManager.GetLogger("ErrorController");
            logger.Debug("Entering ErrorController.Index()");

            Response.StatusCode = statusCode;
            logger.Debug("Finished setting status code");

            // If it's not an AJAX request that triggered this action then just retun the view
            if (!isAjaxRequest)
            {
                var model = new ErrorModel { HttpStatusCode = statusCode, Exception = exception };

                return View(model);
            }
            else
            {
                // Otherwise, if it was an AJAX request, return an anon type with the message from the exception
                var errorObject = new { message = exception.Message };
                return Json(errorObject, JsonRequestBehavior.AllowGet);
            }
        }
	}
}
